package me.km.effects.passive;

import java.util.HashMap;
import me.km.KajetansMod;
import me.km.api.Location;
import me.km.api.Module;
import me.km.api.ModuleListener;
import me.km.api.Utils;
import net.minecraft.block.Block;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.EntityPlayerMP;
import net.minecraft.init.Blocks;
import net.minecraftforge.event.entity.player.PlayerInteractEvent;
import net.minecraftforge.event.world.BlockEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;

public class BlockClickEffects extends ModuleListener
{
    private final HashMap<Location, Data> blocks;
    
    private class Data
    {
        protected EntityPlayerMP p;
        protected int guild;
        protected int taskId;
        
        public Data(EntityPlayerMP p, int taskId)
        {
            this.p = p;
            this.guild = KajetansMod.playerbank.getGuildId(p);
            this.taskId = taskId;
        }
    }
    
    public BlockClickEffects(Module m) 
    {
        super(m);
        blocks = new HashMap<>();
    }
    
    public void registerTeleportBlock(Location l, EntityPlayerMP p, int time)
    {
        int i = KajetansMod.scheduler.scheduleTask(() -> 
        {
            blocks.remove(l);
            l.getWorld().setBlockToAir(l.getBlockPos());
        }, time);
        blocks.put(l, new Data(p, i));
        l.getWorld().setBlockState(l.getBlockPos(), Blocks.SEA_LANTERN.getDefaultState());
        
    }
    
    @SubscribeEvent
    public void interact(BlockEvent.BreakEvent e)
    {       
        Block b = e.getWorld().getBlockState(e.getPos()).getBlock();
        if(b == Blocks.SEA_LANTERN ||
            !KajetansMod.worldManager.getWorldPreferences(e.getWorld()).skills)
        {
            return;
        }
        if(blocks.containsKey(new Location(e.getWorld(), e.getPos())))
        {
            e.setCanceled(true);
        }
    }
    
    @SubscribeEvent
    public void interact(PlayerInteractEvent.RightClickBlock e)
    {       
        Block b = e.getWorld().getBlockState(e.getPos()).getBlock();
        if(b == Blocks.SEA_LANTERN ||
            !KajetansMod.worldManager.getWorldPreferences(e.getWorld()).skills)
        {
            return;
        }
        Location l = new Location(e.getWorld(), e.getPos());
        Data data = blocks.get(l);
        if(data == null)
        {
            return;
        }
        EntityPlayer p = e.getEntityPlayer();
        if(data.guild == KajetansMod.playerbank.getGuildId(p))
        {
            if(data.p.isEntityAlive())
            {
                Utils.teleportEntity(p, data.p);
            }
            blocks.remove(l);
            KajetansMod.scheduler.cancelTask(data.taskId);
            l.getWorld().setBlockToAir(l.getBlockPos());
        }
    }
}