package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.BlockDamageEvent;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class BlockDamageEffects extends ModuleListener
{
    public BlockDamageEffects(Module m) 
    {
        super(m);
    }
    
    @EventHandler(ignoreCancelled = true)
    public void onBlockDamage(BlockDamageEvent e)
    {       
        Player p = (Player) e.getPlayer();
        if(!KajetansTools.worldManager.getWorldPreferences(p.getWorld()).skills)
        {
            return;
        }
        
        Block b = (Block) e.getBlock();
        
        // OP-Effekt aus Prinzip entfernen
        if(p.hasPotionEffect(PotionEffectType.FAST_DIGGING))
        {           
            if(p.getActivePotionEffects().stream()
                .anyMatch(pe -> pe.getType().equals(PotionEffectType.FAST_DIGGING) && 
                                pe.getDuration() > 20000))
            {
                p.removePotionEffect(PotionEffectType.FAST_DIGGING);
            }
        }
               
        // Speed up with prefered Blocks of current job
        int digging = EffectUtils.getEffectLevel(p, Effect.FAST_DIGGING);
        if(digging >= 1 && KajetansTools.jobs.isPreferedMaterial(p, b.getType()))
        {
            p.addPotionEffect(new PotionEffect(PotionEffectType.FAST_DIGGING, 999999, digging - 1), true);
        }
    }
}
