package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.api.Utils;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import org.bukkit.entity.Entity;
import org.bukkit.entity.EntityType;
import org.bukkit.entity.Player;
import org.bukkit.entity.Projectile;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.ProjectileLaunchEvent;
import org.bukkit.inventory.ItemStack;

public class EnderpearlEffects extends ModuleListener 
{
    public EnderpearlEffects(Module m)
    {
        super(m);
    }
       
    @EventHandler(ignoreCancelled = true)
    public void preventEnderPearlDamage(EntityDamageByEntityEvent e)
    {
        Entity ent = e.getEntity();
        if(e.getCause() == EntityDamageEvent.DamageCause.FALL &&
            ent instanceof Player && 
            e.getDamager().getType() == EntityType.ENDER_PEARL &&
            KajetansTools.worldManager.getWorldPreferences(ent.getWorld()).skills &&
            EffectUtils.getEffectLevel((Player) ent, Effect.NO_ENDERPEARL_DAMAGE) >= 1)
        {
            e.setCancelled(true);
        }
    }
    
    @EventHandler(ignoreCancelled = true)
    public void PlayerUsesEnderPearlEvent(ProjectileLaunchEvent e)
    {
        Projectile pro = e.getEntity();
        if(Utils.randomBoolean() ||
            pro.getType() != EntityType.ENDER_PEARL || 
            !(pro.getShooter() instanceof Player) ||
            !KajetansTools.worldManager.getWorldPreferences(pro.getWorld()).skills)
        {
            return;
        }
        Player p = (Player) pro.getShooter();
        if(EffectUtils.getEffectLevel(p, Effect.PEARL_SAVER) >= 1)
        {     
            ItemStack stack = p.getInventory().getItemInMainHand(); 
            stack.setAmount(stack.getAmount() + 1); 
            p.getInventory().setItemInMainHand(stack);
        }
    }
    
    @EventHandler(ignoreCancelled = true)
    public void EnderPearlSpeedEvent(ProjectileLaunchEvent e)
    {       
        Projectile pro = e.getEntity();
        if(pro.getType() == EntityType.ENDER_PEARL &&
            pro.getShooter() instanceof Player &&
            KajetansTools.worldManager.getWorldPreferences(pro.getWorld()).skills)
        {
            int speed = EffectUtils.getEffectLevel((Player) pro.getShooter(), Effect.FAST_ENDERPEARL_SHOOT);
            if(speed >= 1)
            {
                pro.setVelocity(pro.getVelocity().multiply(speed + 1));
            }
        }
    }
}
