package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.api.Utils;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import me.kt.nms.NmsUtilities;
import me.kt.playerbank.PlayerData;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntityDamageByEntityEvent;
import org.bukkit.event.entity.EntityDamageEvent;
import org.bukkit.event.entity.EntityDamageEvent.DamageCause;
import org.bukkit.potion.PotionEffect;
import org.bukkit.potion.PotionEffectType;

public class EntityDamageEffects extends ModuleListener
{
    public EntityDamageEffects(Module m) 
    {
        super(m);
    }
    
    @EventHandler
    public void damageHandler(EntityDamageEvent e)
    {           
        if(!(e.getEntity() instanceof Player) || 
            !KajetansTools.worldManager.getWorldPreferences(e.getEntity().getWorld()).skills)
        {
            return;
        } 
        Player p = (Player) e.getEntity();
        PlayerData data = KajetansTools.playerbank.getData(p);
        
        int reducer = EffectUtils.getEffectLevel(p, Effect.LESS_DAMAGE);
        if(reducer > 0)
        {
            e.setDamage(e.getFinalDamage() / (reducer + 1));
        }
        
        if(data.hasData("shadow"))
        {
            NmsUtilities.setInvisible(false, p);
            data.removeData("shadow");
        } 
        
        DamageCause cause = e.getCause();
        if(cause == DamageCause.POISON && 
            EffectUtils.getEffectLevel(p, Effect.NO_POISON) >= 1)
        {
            e.setCancelled(true);
        } 
        else if(e.getCause() == DamageCause.FALL)
        {
            if(data.hasData("fallimmunity"))
            {
                e.setCancelled(true);
                return;
            }
            int fall = EffectUtils.getEffectLevel(p, Effect.LESS_FALL_DAMAGE);
            if(fall >= 1)
            {
                e.setDamage(e.getDamage() / (fall * 2 + 1));
            }
        }
    }
    
    @EventHandler(ignoreCancelled = true)
    public void onEntityDamage(EntityDamageByEntityEvent e)
    {           
        if(!(e.getDamager() instanceof Player) || 
            e.getCause() != EntityDamageEvent.DamageCause.ENTITY_ATTACK ||
            !KajetansTools.worldManager.getWorldPreferences(e.getEntity().getWorld()).skills)
        {
            return;
        }  
        Player p = (Player) e.getDamager();
        Utils.ToolTypes tt = Utils.getToolType(p.getInventory().getItemInMainHand());
        double damageBonus = 1;
        if(tt != null)
        {
            switch(tt)
            {
                case AXE:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_AXE_DAMAGE);
                    break;
                case HOE:  
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_HOE_DAMAGE);
                    break;
                case PICKAXE:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_PICKAXE_DAMAGE);
                    break;
                case SHOVEL:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_SHOVEL_DAMAGE);
                    break;
                case SWORD:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_SWORD_DAMAGE);
                    break;
                case DAGGER:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_DAGGER_DAMAGE);
                    break;
                case HAMMER:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_HAMMER_DAMAGE);
                    break;
                case STICK:
                    damageBonus += 0.1d * EffectUtils.getEffectLevel(p, Effect.MORE_STICK_DAMAGE);
                    break;
            }
        }
        
        PlayerData data = KajetansTools.playerbank.getData(p);

        if(data.removeData("shadowhit"))
        {
            p.addPotionEffect(new PotionEffect(PotionEffectType.SPEED, 40, 1), true);
            p.addPotionEffect(new PotionEffect(PotionEffectType.INVISIBILITY, 40, 0), true);
        }
        
        if(e.getEntity() instanceof Player)
        {
            Player victim = (Player) e.getEntity();
            Player damager = KajetansTools.playerbank.getData(victim).getData("doomed", Player.class);
            if(damager != null && damager.equals(p))
            {
                damageBonus *= 1.2d;
            }
        }
        
        if(e.getEntity() instanceof LivingEntity && data.hasData("poisonedblade"))
        {
            ((LivingEntity) e.getEntity()).addPotionEffect(new PotionEffect(PotionEffectType.POISON, 80, 1), true);
        }
        
        double powerAttack = data.getDouble("powerattack");
        if(powerAttack != 0)
        {
            damageBonus *= powerAttack;
            data.removeData("powerattack");
        }
        
        e.setDamage(e.getDamage() * damageBonus);
    }
}
