package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.ItemStackBuilder;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.api.Utils;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import org.bukkit.entity.LivingEntity;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.EventPriority;
import org.bukkit.event.entity.EntityDeathEvent;
import org.bukkit.inventory.ItemStack;

public class EntityDeath extends ModuleListener
{
    public EntityDeath(Module m) 
    {
        super(m);
    }
    
    // High, da die Drops vorher noch durch SnuviScript geändert werden können
    @EventHandler(priority = EventPriority.HIGH)
    public void onEntityDeath(EntityDeathEvent e)
    {
        LivingEntity ent = e.getEntity();
        if(!KajetansTools.worldManager.getWorldPreferences(ent.getWorld()).skills)
        {
            return;
        }
        Player p = ent.getKiller();              
        if(p == null)
        {
            return;
        }
        int xp = EffectUtils.getEffectLevel(p, Effect.XP_COLLECTOR);
        if(xp >= 1)
        {
            float i = e.getDroppedExp();
            i *= 1 + xp / 5f;
            e.setDroppedExp((int) i);
        }

        int drops = EffectUtils.getEffectLevel(p, Effect.MORE_DROPS);
        if(drops >= 1)
        {
            int random;
            for(ItemStack stack : e.getDrops())
            {
                random = Utils.randomInt(-2, drops);
                if(random >= 1)
                {
                    new ItemStackBuilder(stack, random).drop(e.getEntity().getLocation());
                }
            }
        }
    }
}
