package me.km.effects.passive;

import java.util.NoSuchElementException;
import me.kt.KajetansTools;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.api.Utils;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import org.bukkit.Location;
import org.bukkit.Material;
import org.bukkit.enchantments.Enchantment;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Item;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.player.PlayerFishEvent;
import org.bukkit.inventory.ItemStack;
import org.bukkit.potion.PotionEffectType;

public class Fishing extends ModuleListener
{
    public Fishing(Module m) 
    {
        super(m);
    }
    
    @EventHandler(ignoreCancelled = true)
    public void onFishing(PlayerFishEvent e)
    {
        Player p = e.getPlayer();
        if(!KajetansTools.worldManager.getWorldPreferences(p.getWorld()).skills)
        {
            return;
        }
        int fishing = EffectUtils.getEffectLevel(p, Effect.FISHING);
        if(fishing < 1)
        {
            return;
        }
        Entity ent = e.getCaught();
        if(ent == null || !(ent instanceof Item))
        {
            return;
        }
        
        ItemStack tool = p.getInventory().getItemInMainHand();
        Item item = (Item) ent;
        Location l = item.getLocation();        
        int random = Utils.randomInt(0, fishing);
        Item addDrop;
        for(int i = 0; i < random; i++)
        {
            addDrop = l.getWorld().dropItem(p.getLocation(), generateFish(tool, p));
            addDrop.setVelocity(item.getVelocity());
        }
    }
    
    private ItemStack generateFish(ItemStack tool, Player p)
    {
        int luck = 0;
        try
        {
            luck = p.getActivePotionEffects().stream()
                    .filter((pe) -> (pe.getType().equals(PotionEffectType.LUCK)))
                    .findFirst().get().getAmplifier() + 1;
        }
        catch(NoSuchElementException ex)
        {
        }
        try
        {
            luck -= p.getActivePotionEffects().stream()
                    .filter((pe) -> (pe.getType().equals(PotionEffectType.UNLUCK)))
                    .findFirst().get().getAmplifier() + 1;
        }
        catch(NoSuchElementException ex)
        {
        }
        luck *= 10;
        
        int luckOfSea = tool.getEnchantmentLevel(Enchantment.LUCK);
        int junk = 100 - 20 * luckOfSea - 2 * luck;
        int treasure = 50 + 21 * luckOfSea + 2 * luck;
        int fish = 850 - luck;
        if(treasure < 0)
        {
            treasure = 0;
        }
        if(junk < 0)
        {
            junk = 0;
        }
        if(fish < 0)
        {
            fish = 0;
        }
        
        int random = Utils.randomInt(1, junk + treasure + fish);     
        if(random <= junk) //Junk
        {
            random = Utils.randomInt(1, 92);
            if(random <= 10)
            {
                return new ItemStack(Material.BOWL);
            }
            else if(random <= 12)
            {
                return new ItemStack(Material.FISHING_ROD, 1, (short) Utils.randomInt(6, 64));
            }
            else if(random <= 22)
            {
                return new ItemStack(Material.LEATHER);
            }
            else if(random <= 32)
            {
                return new ItemStack(Material.LEATHER_BOOTS, 1, (short) Utils.randomInt(6, 66));
            }
            else if(random <= 42)
            {
                return new ItemStack(Material.ROTTEN_FLESH);
            }
            else if(random <= 47)
            {
                return new ItemStack(Material.STICK);
            }
            else if(random <= 52)
            {
                return new ItemStack(Material.STRING);
            }
            else if(random <= 62)
            {
                return new ItemStack(Material.POTION);
            }
            else if(random <= 72)
            {
                return new ItemStack(Material.BONE);
            }
            else if(random <= 82)
            {
                return new ItemStack(Material.INK_SACK);
            }
            return new ItemStack(Material.TRIPWIRE_HOOK);
        }
        else if(random <= junk + treasure) // Treasure
        {
            random = Utils.randomInt(1, 6);
            switch(random)
            {
                case 1:
                    return Utils.randomEnchantment(new ItemStack(Material.BOW, 1, (short) Utils.randomInt(288, 384))); 
                case 2:
                    return Utils.randomEnchantment(new ItemStack(Material.ENCHANTED_BOOK)); 
                case 3:
                    return Utils.randomEnchantment(new ItemStack(Material.FISHING_ROD, 1, (short) Utils.randomInt(48, 64))); 
                case 4:
                    return new ItemStack(Material.NAME_TAG);
                case 5:
                    return new ItemStack(Material.SADDLE);
                case 6:
                    return new ItemStack(Material.WATER_LILY);
            }
        }
        
        random = Utils.randomInt(1, 100);
        if(random <= 13)
        {
            return new ItemStack(Material.RAW_FISH, 1, (short) 3);
        }
        else if(random <= 15)
        {
            return new ItemStack(Material.RAW_FISH, 1, (short) 2);
        }
        else if(random <= 40)
        {
            return new ItemStack(Material.RAW_FISH, 1, (short) 1);
        }
        return new ItemStack(Material.RAW_FISH);
    }
}
