package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.ItemStackBuilder;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.api.Utils;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import me.kt.plots.ProtectionBank;
import org.bukkit.Material;
import org.bukkit.block.Block;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.EquipmentSlot;

public class GoldRiverEffects extends ModuleListener
{    
    public GoldRiverEffects(Module m)
    {
        super(m);
    }
    
    @EventHandler
    public void GoldWashingEvent(PlayerInteractEvent e)
    {
        if(e.getHand() == EquipmentSlot.OFF_HAND || e.getAction() != Action.RIGHT_CLICK_BLOCK)
        {
            return;
        }
        Block b = e.getClickedBlock();
        Player p = e.getPlayer();
        if(b == null || 
            b.getType() != Material.GOLD_ORE || 
            !b.getRelative(0, 1, 0).isLiquid() ||
            p.getInventory().getItemInMainHand().getType() != Material.BOWL || 
            !KajetansTools.worldManager.getWorldPreferences(b.getWorld()).skills ||
            EffectUtils.getEffectLevel(p, Effect.GOLD_WASHER) < 1 || 
            !KajetansTools.plots.getDataBank(ProtectionBank.class).hasTag(b.getLocation(), "gold"))
        {
            return;
        }
        new ItemStackBuilder(Material.GOLD_NUGGET, Utils.randomInt(1, 2)).drop(b.getLocation().add(0, 1, 0));
        this.getModule().send(p, "Du hast Gold gefunden!");
        if(Utils.randomInt(1, 4) == 1)
        {
            this.getModule().send(p, "Die Goldader ist erschöpft!");
            b.setType(Material.STONE);                
        }            
    }
    
    @EventHandler
    public void GoldWashingRespawnEvent(PlayerInteractEvent e)
    {
        if(e.getHand() == EquipmentSlot.OFF_HAND || e.getAction() != Action.RIGHT_CLICK_BLOCK)
        {
            return;
        }
        Block b = e.getClickedBlock();
        Player p = e.getPlayer();
        if(b == null || 
            b.getType() != Material.STONE || 
            !b.getRelative(0, 1, 0).isLiquid() ||
            Utils.getToolType(p.getInventory().getItemInMainHand()) != Utils.ToolTypes.SHOVEL ||
            !KajetansTools.worldManager.getWorldPreferences(b.getWorld()).skills ||
            EffectUtils.getEffectLevel(p, Effect.GOLD_RUSH) < 1 ||
            !KajetansTools.plots.getDataBank(ProtectionBank.class).hasTag(b.getLocation(), "gold"))
        {
            return;
        }
        this.getModule().send(p, "Du hast eine neue Goldader gefunden!");     
        b.setType(Material.GOLD_ORE); 
        Utils.damageItemInHand(p, 15);
    }
}
