package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.Utils;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.effects.ActiveEffectBase;
import java.util.List;
import me.kt.custom.CustomItemUtils;
import me.kt.custom.CustomMaterial;
import me.kt.effects.Effect;
import me.kt.effects.EffectCause;
import me.kt.effects.EffectUtils;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.block.Action;
import org.bukkit.event.player.PlayerInteractEvent;
import org.bukkit.inventory.EquipmentSlot;
import org.bukkit.inventory.ItemStack;
import org.bukkit.inventory.meta.ItemMeta;

public class MagicWands extends ModuleListener
{          
    public MagicWands(Module m)
    {
        super(m);
    }
   
    @EventHandler
    public void PlayerUsesWand(PlayerInteractEvent e)
    {
        Player p = e.getPlayer();
        if(e.getHand() == EquipmentSlot.OFF_HAND ||
            (e.getAction() != Action.RIGHT_CLICK_AIR && e.getAction() != Action.RIGHT_CLICK_BLOCK) ||
            !KajetansTools.worldManager.getWorldPreferences(p.getWorld()).skills)
        {
            return;
        }
        ItemStack stack = p.getInventory().getItemInMainHand();
        CustomMaterial cm = CustomMaterial.getCustomMaterial(stack);
        if(cm != null && cm.getToolType() == Utils.ToolTypes.WAND)
        {
            int wand = EffectUtils.getEffectLevel(p, Effect.USE_WAND);
            if(wand < 1)
            {
                this.getModule().send(p, "Du kannst keine Zauberstäbe benutzen.");
                return;
            }
            ItemMeta meta = stack.getItemMeta();
            List<String> lore = meta.getLore();
            for(String s : lore)
            {
                if(s.startsWith("Effect") && s.length() > 8)
                {
                    Class<? extends ActiveEffectBase> c = EffectUtils.getEffectClass(s.substring(8));
                    if(c == null)
                    { 
                        this.getModule().send(p, "Der Zauberstab ist korrupt.");
                        return;
                    }
                    int power;
                    switch(cm)
                    {
                        case WOOD_WAND:     power = 1; break;
                        case STONE_WAND:    power = 2; break; 
                        case REDSTONE_WAND: power = 3; break;
                        case IRON_WAND:     power = 3; break;
                        case LAPIS_WAND:    power = 4; break;
                        case GOLD_WAND:     power = 5; break;
                        case DIAMOND_WAND:  power = 5; break;
                        case EMERALD_WAND:  power = 6; break;
                        default:            power = 1; break;
                    }
                    if(ActiveEffectBase.executeEffect(c, p, power, power, EffectCause.WAND))
                    {
                        CustomItemUtils.lowerDurability(p, 1);
                    }
                }
            }
        }
    }    
}

