package me.km.effects.passive;

import me.kt.KajetansTools;
import me.kt.api.Module;
import me.kt.api.ModuleListener;
import me.kt.api.Utils;
import me.kt.effects.Effect;
import me.kt.effects.EffectUtils;
import org.bukkit.entity.Entity;
import org.bukkit.entity.Monster;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.entity.EntityTargetEvent;
import org.bukkit.event.entity.EntityTargetLivingEntityEvent;
import org.bukkit.potion.PotionEffectType;

public class TargetEntity extends ModuleListener
{
    public TargetEntity(Module m) 
    {
        super(m);
    }
    
    @EventHandler(ignoreCancelled = true)
    public void avoidTargetting(EntityTargetLivingEntityEvent e)
    {
        Entity ent = e.getTarget();
        if(ent == null || e.getReason() != EntityTargetEvent.TargetReason.CLOSEST_PLAYER || 
            !(ent instanceof Player) || !KajetansTools.worldManager.getWorldPreferences(ent.getWorld()).skills)
        {
            return;
        }
        Player p = (Player) ent;  
        if(EffectUtils.getEffectLevel(p, Effect.SNEAKING) >= 1 && p.hasPotionEffect(PotionEffectType.INVISIBILITY))
        {       
            e.setCancelled(true);
        }
        else if(EffectUtils.getEffectLevel(p, Effect.SCENT) >= 1 && e.getEntity() instanceof Monster)
        {      
            this.getModule().send(p, "Ein " + Utils.formatString(e.getEntity().getName()) + " hat dich bemerkt!");
        }
    }
}
